﻿using System;
using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using System.Collections.Generic;
using MVR.FileManagementSecure;
using SimpleJSON;
using MeshVR;
using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;
using AssetBundles;
using MVR;

namespace ConditionalTrigger
{
    public class TC_CheckIfVR : TriggerCondition
    {
        protected JSONStorableBool js_VRMode;

        public TC_CheckIfVR(ConditionalTrigger _manager, int _id) : base(_manager, _id)
        {
            js_VRMode = new JSONStorableBool(id + "VRMode", true);

            manager.RegisterBool(js_VRMode);
        }

        public override void Init()
        {
        }

        public override bool Result()
        {
            return CheckCondition();
        }

        public override void Update()
        {
        }

        public override void ShowUI()
        {
            base.ShowUI();

            manager.CreateTempSpacer(25f);

            manager.CreateTempStaticText("Title", "<color=#000><size=30><b>Check VR/Desktop </b></size></color>", 40);

            manager.CreateTempToggle(js_VRMode);
        }

        public override void OnDestroy()
        {
            base.OnDestroy();

            manager.DeregisterBool(js_VRMode);
        }

        public override void UpdateID(int _newID)
        {
            base.UpdateID(_newID);

            js_VRMode.name = id + "Mode";
        }

        public override bool CanReset
        {
            get
            {
                if (!js_UseForResetCheck.val)
                    return true;

                return !CheckCondition();
            }
        }
      
        public bool CheckCondition()
        {
            if (SuperController.singleton.IsMonitorOnly && !js_VRMode.val)
                return true;

            if (!SuperController.singleton.IsMonitorOnly && js_VRMode.val)
                return true;

            return false;
        }
    }

}